
var table 
    
    function edit_items(itemid,customer_full_name,customer_phone,notes){
       
       customer_full_name = decodeURIComponent_back(customer_full_name);
       customer_phone     = decodeURIComponent_back(customer_phone);
       notes              = decodeURIComponent_back(notes);

       $("#edit_objid").val(itemid);
       $("#edit_owner_full_name").val(customer_full_name);
      
       $("#edit_owner_phone").val(customer_phone);
       
       $("#edit_owner_note").val(notes);
       $('#edit_form_cont').modal('toggle');
    }

    function delete_items(itemid) {
        swal({
            title: Translation("هل انت متأكد؟!"),
            text: Translation("سوف لن تستطيع استرجاع المعلومات المرتبطة بهذا السجل في حالة المسح"),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#EF5350",
            confirmButtonText: Translation("موافق: امسح!"),
            cancelButtonText: Translation("الغاء الامر"),
            closeOnConfirm: false,
            closeOnCancel: true
        },
        function(isConfirm){
            if (isConfirm) {
              $.ajax({
                url: "models/crul_owner.php",
                type:"POST",
                dataType: "JSON",
                data: {"type":"delete","obj_id":itemid} ,
                complete:function(){
                 
                },
                beforeSend:function(){
                 
                },
                success: function(res) {
                  if(res.is_success == true){
                    swal({
                                title: Translation("حذف!"),
                                text: Translation(res.data),
                                confirmButtonColor: "#66BB6A",
                                type: "success"
                            });
                    $(".datatable-column-search-inputs").DataTable().ajax.reload(null, false);
                  }else{
                    swal({
                                title: Translation("خطأ"),
                                text: Translation(res.data),
                                confirmButtonColor: "#2196F3",
                                type: "error"
                            });
                  }
                }
            });
            }
        }); // /confirm
    }

  function Checks(id,types=null,min=null,max=null){
      var name = $("#"+id).val();
      if(types == null){  // it mean string

            if(min !=null && max !=null){
                if(name =='' || name.length < min || name.length > max){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter the Required Field with minimum length of "+ min + " and maximum length " + max,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else if(min !=null && max ==null){
                if(name ==''  || name.length < min ){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter the Required Field with minimum length of "+ min ,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else if(min ==null && max !=null){
                if(name ==''  ||  name.length > max){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter the Required Field with  maximum length of " + max,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else{

                if(name ==''){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Field should not be empty",
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }

            }

      }else if(types == 'No'){  // it mean numbers

            if(min !=null && max !=null){
                if(name !='' && isNaN(name) || name < min || name > max){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter Numeric Value between "+ min + " and " + max,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else if(min !=null && max ==null){
                if(name !='' && isNaN(name) || name < min ){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter Numeric Value Greater than "+ min,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else if(min ==null && max !=null){
                if(name !='' && isNaN(name) ||  name > max){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter Numeric Value Less than " + max,
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }
            }else{

                if(name !='' && isNaN(name)){
                  $("#"+id).closest('.form-group').removeClass('has-success');
                  $("#"+id).closest('.form-group').addClass('has-error');

                  noty({
                          width: 200,
                          text: "Please Enter Numeric Value",
                          type: 'error',
                          dismissQueue: true,
                          timeout: 3000,
                          layout: 'topRight',
                    });
                  return false;
                }else{
                    $("#"+id).closest('.form-group').removeClass('has-error');
                    $("#"+id).closest('.form-group').addClass('has-success');
                    return true;
                }

            }

      }
  }


    
$(document).ready(function() {
  
    $('#add_form').submit(function(event) {
            event.preventDefault();
            

            var owner_full_name    = $("#owner_full_name").val();
            
            var owner_phone        = $("#owner_phone").val();
            
            var owner_note         = $("#owner_note").val();

            var Check1 = true;
            var Check2 = true;
            var Check3 = true;
            var Check4 = true;
            var Check5 = true;

            var Check1    = Checks('owner_full_name');
            // var Check2    = Checks('customer_email');
            // var Check3    = Checks('supplier_phone');
            // var Check4    = Checks('customer_address');
            // var Check5    = Checks('customer_type');
            


            if(Check1 && Check2 && Check3 && Check4 && Check5){
              $("#submit_add_btn").attr('disabled',true);
                $.ajax({
                    url: "models/crul_owner.php",
                    type:"POST",
                    dataType : "JSON",
                    data : {owner_full_name:owner_full_name,
                            owner_phone:owner_phone,
                            owner_note:owner_note,
                            
                            type:'create'}
                })
                .done(function(res) {
                  //alert(res);
                  if(res.is_success == false){
                      noty({
                        width: 200,
                        text: Translation(res.data),
                        type: 'error',
                        dismissQueue: true,
                        timeout: 3000,
                        layout: 'topRight',
                      });
                      // $("#add-form-cont").collapse('hide');
                  }else{
                      $("#add_form")[0].reset();
                      $(".datatable-column-search-inputs").DataTable().ajax.reload(null, false);
                      $("#add-form-cont").collapse('hide');
                      noty({
                                      width: 200,
                                      text: Translation(res.data),
                                      type: 'success',
                                      dismissQueue: true,
                                      timeout: 3000,
                                      layout: 'topRight',
                                });
                  }
                  $("#submit_add_btn").attr('disabled',false);
                })
                .fail(function(err) {
                   swal({
                      title: Translation("خطأ"),
                      text: (err),
                      confirmButtonColor: "#66BB6A",
                      type: "error"
                    });
                   $("#submit_add_btn").attr('disabled',false);
                })
                .always(function() {
                    console.log("complete");
                });
            }

    });


     // submit editable Visa Application form
  $('#edit_form').submit(function(event) {
            event.preventDefault();
            
            
            var catId    = $("#edit_objid").val();

            var owner_full_name    = $("#edit_owner_full_name").val();
            
            var owner_phone        = $("#edit_owner_phone").val();
            
            var owner_note         = $("#edit_owner_note").val();

            var Check1 = true;
            var Check2 = true;
            var Check3 = true;
            var Check4 = true;
            var Check5 = true;

            var Check1    = Checks('edit_owner_full_name');
            // var Check2    = Checks('edit_customer_email');
            // var Check3    = Checks('edit_supplier_phone');
            // var Check4    = Checks('edit_customer_address');
            // var Check5    = Checks('edit_customer_type');

            

            if(Check1 && Check2 && Check3 && Check4 && Check5){
                $.ajax({
                    url: "models/crul_owner.php",
                    type:"POST",
                    dataType : "JSON",
                    data : {owner_full_name:owner_full_name,
                            owner_phone:owner_phone,
                            owner_note:owner_note,
                            obj_id:catId,
                            type:'update'},
                    complete:function(){
                      //hideLoader();
                    },
                    beforeSend:function(){
                      //showLoader("Updating Category");
                    },
                    success: function(res) {
                      if(res.is_success == false){
                          noty({
                            width: 200,
                            text: Translation(res.data),
                            type: 'error',
                            dismissQueue: true,
                            timeout: 3000,
                            layout: 'topRight',
                          });
                        // $("#edit-form-cont").collapse('hide');
                        $("#edit_form")[0].reset();
                        
                      }else {
                        $("#edit_form")[0].reset();
                        $(".datatable-column-search-inputs").DataTable().ajax.reload(null, false);
                        
                        $('#edit_form_cont').modal('toggle');

                        noty({
                                        width: 200,
                                        text: Translation(res.data),
                                        type: 'success',
                                        dismissQueue: true,
                                        timeout: 3000,
                                        layout: 'topRight',
                                  });
                      }
                    }
                });
              }
    });

    
    

});






$(function() {
//var singleSelect = $('.datatable-column-search-inputs').DataTable();
    
  // Initialize plugin Tag Input
    $('.tokenfield-primary').tokenfield();

    // Add class when token is created
    $('.tokenfield-primary').on('tokenfield:createdtoken', function (e) {
        $(e.relatedTarget).addClass('bg-primary')
    });




   // Setting datatable defaults
    $.extend( $.fn.dataTable.defaults, {
        autoWidth: false,
        columnDefs: [{ 
            orderable: false,
            width: '100px',
            targets: [ 4 ]
        }],
        dom: '<"datatable-header"fBl><"datatable-scroll"t><"datatable-footer"ip>',
        language: {
            search: '<span>'+Translation('بحث')+'</span> _INPUT_',
            searchPlaceholder: Translation('بحث عن')+' ...',
            lengthMenu: '<span>'+Translation('عرض')+' :</span> _MENU_',
            paginate: { 'first': 'First', 'last': 'Last', 'next': '&larr;', 'previous': '&rarr;' }
        },
        drawCallback: function () {
            $(this).find('tbody tr').slice(-3).find('.dropdown, .btn-group').addClass('dropup');
        },
        preDrawCallback: function() {
            $(this).find('tbody tr').slice(-3).find('.dropdown, .btn-group').removeClass('dropup');
        }
    });

    

    // Individual column searching with text inputs
    $('.datatable-column-search-inputs tfoot td').not(':last-child').each(function () {
        var title = $('.datatable-column-search-inputs thead th').eq($(this).index()).text();
        $(this).html('<input type="text" class="form-control input-sm" placeholder="'+Translation('بحث عن')+' '+title+'" />');
    });
    
    
   var query_typ  = getQueryVariable("typ");

   
   var table = $('.datatable-column-search-inputs').DataTable({
        buttons: {            
            buttons: [
                {
                    extend: 'copyHtml5',
                    className: 'btn btn-default',
                    exportOptions: {
                        columns: [ 0, ':visible' ]
                    }
                },
                {
                    extend: 'excelHtml5',
                    className: 'btn btn-default',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
                {
                    extend: 'pdfHtml5',
                    className: 'btn btn-default',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
                {
                    extend: 'print',
                    className: 'btn btn-default',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
                {
                    extend: 'colvis',
                    text: '<i class="icon-three-bars"></i> <span class="caret"></span>',
                    className: 'btn bg-blue btn-icon'
                }
                
            ]
        },
        lengthMenu: [
            [  10, 25, 50, 100 ],
            [  '10', '25', '50', '100' ]
        ],
        "processing": true,
        "serverSide": true,
        "ajax": {
        "url" : "models/crul_owner.php",
        "data": function(d){
          d.type = "load";
          if(query_typ !='not'){
            d.typ =query_typ ;
          }
        }
        },
        drawCallback: function() {
                  $('[data-popup=tooltip]').tooltip();
                  $('[data-popup=popover-custom]').popover({
                    template: '<div class="popover  border-teal-400"><div class="arrow"></div><h3 class="popover-title bg-teal-400"></h3><div class="popover-content"></div></div>'
                  });

            },
        "columnDefs": [
          {
              "targets": 5,
              "data": null,
              "render": function (data,type,row) {

                    if(IS_VIEW==0){


                            return  `<ul class='icons-list pull-right'>
                                      
                                        <li class='text-primary-600'>
                                            <a href='#' class='text-primary-400' onclick="edit_items(`+row[0]+`,'`+escapeHtml(row[1])+`','`+escapeHtml(row[2])+`','`+escapeHtml(row[3])+`')" data-popup='tooltip' data-original-title='`+Translation('تحرير')+`'>
                                                <i class='icon-pencil7'></i>
                                            </a>
                                        </li>

                                        <li class='text-danger-600'>
                                            <a href='#' class='text-danger-400' onclick="delete_items(`+row[0]+`)" data-popup='tooltip' data-original-title='`+Translation('حذف')+`'>
                                                <i class='icon-trash'></i>
                                            </a>
                                        </li>

                                    </ul>`;
                    }else{
                      return '';
                    }
                }
          },

          {
             "render": function(data, type, row){


                      // return  `<a href='index.php?p=invoice&id=`+row[0]+`'  data-popup='tooltip' data-original-title='Show All Invoices for this Customer'>`+data+`</a>`;
                      return  `<a onclick="load_account_statment(`+row[0]+`)"  data-popup='tooltip' data-original-title='`+Translation('عرض جميع كشوفات الحساب لهذا الزبون')+`'>`+data+`</a>`;


             },
             "targets": 1
          },

          {
             "render": function(data, type, row){

                   
                     status = '<span class="badge bg-success  btn-block ">'+data+'</span>';
                  
                     status1 = '';
                  
                      // return  `<a href='index.php?p=invoice&id=`+row[0]+`'  data-popup='tooltip' data-original-title='Show All Invoices for this Customer'>`+data+`</a>`;
                      return  status + status1;


             },
             "targets": 3
          },


         
            
            
        ],
        "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {


            if(   aData[4] == 0 ){
                $(nRow).children().each(function (index, td) {
                    $(this).addClass('warning-active');
                });
            }
        },
        "order": [[0,'desc']],
                "displayLength": 25,
 

        initComplete: function () {
         
        // $("div.datatable-header").append(`<a  style="margin-left:15px;" class="btn bg-info-400"  id="headerBtn" onclick="add_item()"> <i class="icon-file-pdf position-right"></i> Add Category </a>`);   
          if(IS_VIEW==0){
         
              $("div.datatable-header").append(`<a data-toggle="collapse"
                                      style="margin-right:10px;"
                                      data-target="#add-form-cont"
                                      href="javascript:;"
                                      aria-controls="add-form-cont"
                                      aria-expanded="false"
                                      class="btn btn-primary"
                                      id="add_Item_Btn">
                                        <i class="`+CURRENT_BTN_ICON+`"></i> `+Translation(CURRENT_BTN)+`
                                    </a>`);  
          }


            this.api().columns().every( function() {
                var column = this;
                

            });
        }
    });

    
    table.columns().every( function () {
        var that = this;
        $('input', this.footer()).on('keyup change', function () {
            that.search(this.value).draw();
        });
    });


    // Single row selection
    
    $('.datatable-column-search-inputs tbody').on('click', 'tr', function() {
        if ($(this).hasClass('success')) {
            $(this).removeClass('success');
        }
        else {
            table.$('tr.success').removeClass('success');
            $(this).addClass('success');
        }
    });


         // change filter to top
    $('.datatable-column-search-inputs tfoot tr').insertAfter($('.datatable-column-search-inputs thead tr'))


    $('.dataTables_length select').select2({
        minimumResultsForSearch: Infinity,
        width: 'auto'
    });


});



